;; Problem 33
;; 20 December 2002

;; The fraction 49/98 is a curious fraction, as an inexperienced mathematician in attempting to simplify it may incorrectly believe that 49/98 = 4/8, which is correct, is obtained by cancelling the 9s.

;; We shall consider fractions like, 30/50 = 3/5, to be trivial examples.

;; There are exactly four non-trivial examples of this type of fraction, less than one in value, and containing two digits in the numerator and denominator.

;; If the product of these four fractions is given in its lowest common terms, find the value of the denominator.

(defun has-property (numerator denominator)
  (let* ((nstr (format nil "~d" numerator))
	 (dstr (format nil "~d" denominator))
	 (n1 (subseq nstr 0 1))
	 (n2 (subseq nstr 1 2))
	 (d1 (subseq dstr 0 1))
	 (d2 (subseq dstr 1 2)))
    (cond
;;      ((equal n1 d1)
;;       (list n2 d2))
;;      ((equal n1 d2)
;;       (list n2 d1))
;;      ((equal n2 d1)
;;       (list n1 d2))
;;      ((equal n2 d2)
;;       (list n1 d1))

      ((and (equal n2 d1)
	    (not (= 0 (read-from-string d2)))
	    (= (/ numerator denominator)
	       (/ (read-from-string n1)
		  (read-from-string d2))))
       (list n1 d2))

      (t
       nil))))

(mapcar #'read-from-string (has-property 49 98))

(defmacro awhen (test &body body)
  `(let ((it ,test))
    (when it
      ,@body)))

(defun find-fracts-with-property ()
  (let ((res (list)))
    (loop for numerator from 10 to 99
	  do
	  (loop for denominator from 10 to 99
		do
		(when (< (/ numerator denominator) 1)
		  (awhen (has-property numerator denominator)
		    (push (list numerator denominator) res)))))
    res))

(find-fracts-with-property)

(* (/ 49 98) (/ 26 65) (/ 19 95) (/ 16 64)); 1/100


